import 'dart:math';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:flutter/src/widgets/placeholder.dart';
import 'package:instagram_clone/screens/post_screen.dart';
import 'package:instagram_clone/screens/profile_screen.dart';
import 'package:instagram_clone/utils/text_utils.dart';
import 'package:instagram_clone/widgets/post_view_widget.dart';
import 'package:instagram_clone/widgets/story_view_widget.dart';



class HomeScreen extends StatefulWidget {
  const HomeScreen({super.key});

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> {
  final TextUtils _textUtils = TextUtils();


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: HomeAppBar(),
      body: RefreshIndicator(
        onRefresh: () async { return Future.delayed(const Duration(seconds: 1)); },
        child: SingleChildScrollView(
          child: Column(
            children: [
              SingleChildScrollView(
                padding: const EdgeInsets.symmetric(horizontal: 10),
                scrollDirection: Axis.horizontal,
                child: Row(
                  children: [
                    Container(
                      width: 70,
                      margin: const EdgeInsets.only(right: 15),
                      child: Column(
                          children: [
                            Container(
                              alignment: Alignment.center,
                              margin: const EdgeInsets.only(top: 10),
                              child: Padding(
                                padding: const EdgeInsets.all(5.0),
                                child: Stack(
                                  alignment: AlignmentDirectional.bottomEnd,
                                  children: [
                                    const CircleAvatar(
                                      radius: 30,
                                      backgroundImage: AssetImage("assets/avaters/Avatar 1.jpg"),
                                    ),
                                    Container(
                                      width: 15,
                                      height: 15,
                                      decoration: BoxDecoration(
                                        color: Colors.green,
                                        shape: BoxShape.circle,
                                        border: Border.all(
                                          color: Colors.white,
                                          width: 0.5, 
                                          ),
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                            ),
                            const SizedBox(height: 10,),
                            _textUtils.normal14Ellipsis("Tin cua ban", Colors.black),
                          ],
                        ),
                    ),//,
                    for (int i=0;i<20;i++)
                      Container(
                        width: 70,
                        margin: const EdgeInsets.only(right: 15),
                        child: Column(
                          children: [
                            const StoryViewWidget(),
                            const SizedBox(height: 10,),
                            _textUtils.normal14Ellipsis("doanvaanha", Colors.black),
                          ],
                        ),
                      ),
                  ]
                ),
              ),
              const SizedBox(height: 20,),
              for (int i=0;i<20;i++)
                const PostViewWidget(),
            ]
          ),
        ),

      ),
    );
  }



  AppBar HomeAppBar() {
    return AppBar(
      backgroundColor: Colors.white,
      elevation: 0.0,
      title: const Text(
        "Instagram",
        style: TextStyle(
          fontFamily: "FontSpring",
          fontSize: 26,
          color: Colors.black,
          ),
        ),
      actions: [
        const Padding(
          padding:  EdgeInsets.only(right: 10),
          child: Icon(
            CupertinoIcons.heart,
            size: 25,
            color: Colors.black,
          ),
          ),
        const SizedBox(width: 10,),
        Padding(
          padding: const EdgeInsets.only(right: 10),
          child: Image.asset(
            "assets/icons/messenger.png",
            color: Colors.black,
            width: 25,
            height: 25,
            ),
          ),
      ],
    );
  }
}

extension AlignmentExtenstion on Alignment {
  Offset toOffsetWithRadius({ double radius = 0.0}){
    final angle = atan2(y,x);
    final polarRadius = radius * min(1.0, sqrt(x * x + y * y));
    final offsetX = polarRadius * cos(angle) + radius;
    final offsetY = polarRadius * sin(angle) + radius;
    return Offset(offsetX, offsetY);
  }
}