import 'dart:ui';

import 'package:flutter/material.dart';

import 'package:rive/rive.dart';

import 'main_screen.dart';

class LoadingScreen extends StatefulWidget {
  const LoadingScreen({super.key});

  @override
  State<LoadingScreen> createState() => _LoadingScreenState();
}

class _LoadingScreenState extends State<LoadingScreen> {
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    _navigatorHome();
  }

  
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Stack(
        children: [
          Positioned(
          width: MediaQuery.of(context).size.width * 1.7,
          left: 100,
          bottom: 100,
          child: Image.asset("assets/Backgrounds/Spline.png"),
          ),
          Positioned.fill(
            child: BackdropFilter(
              filter: ImageFilter.blur(sigmaX: 20, sigmaY: 20),
              child: const SizedBox(),),
            ),
          
          const RiveAnimation.asset(
            "assets/RiveAssets/shapes.riv",
            ),
          Positioned.fill(
            child: BackdropFilter(
              filter: ImageFilter.blur(sigmaX: 30, sigmaY: 30),
              child: const SizedBox(),),
            ),
        ],
        
      ),
    );
  }
  
  void _navigatorHome() async {
    Future.delayed(const Duration(seconds: 5), () {Navigator.of(context).push(
                MaterialPageRoute(builder: (context) => const MainScreen())
              );});
    // Navigator.push(context, MaterialPageRoute(builder: (context) => const MainScreen()));
    
  }
}