import 'dart:async';
import 'package:async/async.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:flutter/src/widgets/placeholder.dart';
import 'package:get/get.dart';
import 'package:instagram_clone/screens/home_screen.dart';
import 'package:instagram_clone/view/cube_page_view.dart';
import 'package:instagram_clone/widgets/cube_widget.dart';

class StoryScreen extends StatefulWidget {
  const StoryScreen({super.key});

  @override
  State<StoryScreen> createState() => _StoryScreenState();
}

class _StoryScreenState extends State<StoryScreen> with TickerProviderStateMixin{
  late PageController _pageController;
  var _current_timer = 0.0;
  var _duration = 10000;
  final List list_image = ["assets/avaters/Avatar 1.jpg", "assets/avaters/Avatar 2.jpg", "assets/avaters/Avatar 3.jpg"];
  Timer? _timer;
  int _current_page = 0;
  int _previous_page = 0;


  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    _current_page = 0;
    _previous_page = _current_page;
    _pageController = PageController(initialPage: _current_page);
    _startTimer();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    _cancelTimer();
    // Future.delayed(const Duration(milliseconds: 500)).then((value) {_pageController.dispose();});
    
    
    super.dispose();

  }



  void _cancelTimer() async{
    _timer?.cancel();
  }


  void _startTimer(){
    // _timer = RestartableTimer(const Duration(seconds: 2), () {
    //   if (_current_page < list_image.length - 1){
    //     _current_page++;
    //   }else{
    //     returnHome();
    //   }

    //   _pageController.animateToPage(
    //     _current_page, 
    //     duration: const Duration(milliseconds: 300), 
    //     curve: Curves.easeOut);
    // });
  
    var onesec = const Duration(milliseconds: 100);
    _current_timer = 0.0;
    _duration = 10000;
    _timer = Timer.periodic(onesec, (timer) { 
      setState(() {
        if (_duration > 0) {
          _duration-=100;
          _current_timer = _duration/10000.0;
        } else {
          if (_current_page < list_image.length - 1){
            _current_page++;
            _pageController.animateToPage(
            _current_page, 
            duration: const Duration(milliseconds: 300), 
            curve: Curves.easeOut, 
            );

            _current_timer = 0.0;
            _duration = 10000;
          }else{
            returnHome();
          }

          
        }
      });
      

    });


  }

  @override
  Widget build(BuildContext context) {
    return Center(
      child: CubePageView.builder(
        
        onPageChanged: (index) {
          _timer?.cancel();
          _startTimer();
          setState(() {
            _previous_page = _current_page;
            _current_page = index;
          });
          
        },
        itemCount: list_image.length, 
        controller: _pageController,
        itemBuilder: (context, index, notifier) {
          return CubeWidget(
            index: index, 
            pageNotifier: notifier, 
            child: Scaffold(
              body: SafeArea(
                child: Container(
                    width: double.infinity,
                    child: Container(
                      width: double.infinity,
                      decoration: BoxDecoration(
                        image: DecorationImage(
                          image: AssetImage(list_image[index]),
                          fit: BoxFit.fill
                          ),
                      ),
                      child: Column(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          
                          LinearProgressIndicator(
                            value: _current_timer,
                          ),
                          const SizedBox(height: 5,),
                          Container(
                            alignment: Alignment.topLeft,
                            child: Row(
                                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                children: [
                                  Row(
                                    crossAxisAlignment: CrossAxisAlignment.center,
                                    mainAxisAlignment: MainAxisAlignment.end,
                                    children: [
                                      const Padding(
                                        padding: const EdgeInsets.symmetric(vertical: 5.0),
                                        child: CircleAvatar(
                                          radius: 20.0,
                                          backgroundImage: AssetImage("assets/avaters/Avatar 6.jpg"),
                                        ),
                                      ),
                                      const SizedBox(width: 20,),
                                      Column(
                                        children: [
                                          Row(
                                            mainAxisAlignment: MainAxisAlignment.center,
                                            children: const [
                                            Text(
                                              "sooyaa__",
                                              style: TextStyle(
                                                color: Colors.white,
                                              ),
                                            ),
                                            Text(
                                              "19 gio",
                                              style: TextStyle(
                                                color: Colors.white,
                                              ),
                                            ),
                                            ],
                                          ),
                                          Row(
                                            mainAxisAlignment: MainAxisAlignment.center,
                                            children: const [
                                            Icon(
                                              Icons.message,
                                              size: 10,
                                              color: Colors.white
                                            ),
                                            Text(
                                              "Xem ban dich", 
                                              style: TextStyle(
                                                color: Colors.white,
                                              ),
                                              )
                                            ],),
                                              
                                        ],
                                      ),
                                    ],
                                  ),
                                  const Icon(
                                    CupertinoIcons.ellipsis_vertical,
                                    color: Colors.white,
                                  ),
                                ],
                              ),
                          ),
                        ],
                      ),
                    ),
                  ),
              ),
              bottomSheet: Container(
                color: Colors.black,
                child: Padding(
                    padding: const EdgeInsets.symmetric(vertical: 10.0),
                    child: Row( 
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Expanded(
                          child: TextField(
                            
                            style: const TextStyle(
                              color: Colors.white,
                            ),
                            
                            decoration: InputDecoration(
                              
                              enabledBorder: OutlineInputBorder(
                                borderRadius: BorderRadius.circular(30.0),
                                borderSide: const BorderSide(
                                  color: Colors.grey,
                                  width: 1.0,
                                  
                                  ),
                                ),
                              
                              hintText: "Gui tin nhan",
                              hintStyle: const TextStyle(
                                color: Colors.white,
                              )
                            ),
                          ),
                      
                        ),
                        const Padding(
                          padding: EdgeInsets.symmetric(horizontal: 5.0),
                          child: Icon(
                            CupertinoIcons.heart,
                            color: Colors.white,
                            ),
                          ),
                          const Padding(
                          padding: EdgeInsets.symmetric(horizontal: 5.0),
                          child: Icon(
                            CupertinoIcons.flame,
                            color: Colors.white,
                            ),
                          ),
                      ],
                    ),
                    ),
              ),
              
            ),
            );
        },
        ),
    );
    
  }
  
  void returnHome() {
    _current_page = 0;
    // _pageController = PageController(initialPage: _current_page);
    _duration = 10000;
    _current_timer = 0.0;
    _previous_page = _current_page;
    _cancelTimer();
    Get.to(() => const HomeScreen(), transition: Transition.zoom, duration: const Duration(seconds: 1));
  }

}


