import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:flutter/src/widgets/placeholder.dart';
import 'package:instagram_clone/models/menu.dart';
import 'package:rive/rive.dart';

class BtnNavButton extends StatelessWidget {
  final Menu menu;
  final VoidCallback onTap;
  final ValueChanged<Artboard> riveOnInit;
  final Menu activeMenu;


  const BtnNavButton({super.key, required this.menu, required this.onTap, required this.riveOnInit, required this.activeMenu});

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: onTap,
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: [
          AnimatedContainer(
            margin: const EdgeInsets.only(bottom: 2),
            duration: const Duration(milliseconds: 400),
            height: 4,
            width: activeMenu == menu ? 20: 0,
            decoration: const BoxDecoration(
              color: Color(0xFF81B4FF),
              borderRadius: BorderRadius.all(Radius.circular(12)),
            ),
          ),

          SizedBox(
            width: 36,
            height: 36,
            child: Opacity(
              opacity: activeMenu == menu ? 1 : 0.5,
              child: RiveAnimation.asset(
                menu.rive.src,
                artboard: menu.rive.artboard,
                onInit: riveOnInit,
              ),
            ),
          ),
        ],
      ),
    );
  }
}