import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:flutter/src/widgets/placeholder.dart';
import 'package:instagram_clone/utils/text_utils.dart';

class PostViewWidget extends StatefulWidget {
  const PostViewWidget({super.key});

  @override
  State<PostViewWidget> createState() => _PostViewWidgetState();
}

class _PostViewWidgetState extends State<PostViewWidget> {
  final TextUtils _textUtils = TextUtils();
  late PageController _pageController;
  final List list_image = ["assets/avaters/Avatar 1.jpg", "assets/avaters/Avatar 2.jpg", "assets/avaters/Avatar 3.jpg"];
  int _current_page = 0;
  
  @override
  void initState() {
    // TODO: implement initState
    _pageController = PageController();
    super.initState();
  }

  @override
  void dispose() {
    _pageController.dispose();
    // TODO: implement dispose
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: const EdgeInsets.only(bottom: 15),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: const EdgeInsets.only(left: 10, right: 10, bottom: 10),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Row(
                  children: [
                    const CircleAvatar(
                      radius: 20,
                      backgroundImage: AssetImage("assets/avaters/Avatar 2.jpg"),
                    ),
                    const SizedBox(width: 10,),
                    _textUtils.bold16("dagfdafsi", Colors.black),
                  ],
                ),
                const Icon(
                  Icons.more_vert_rounded,
                  color: Colors.blue,
                  ),
                ],
              ),
              
            ),
            
            Container(
              alignment: Alignment.center,
              width: double.infinity,
              height: MediaQuery.of(context).size.height * 0.5,
              child: PageView.builder(
                itemCount: list_image.length,
                physics: const ClampingScrollPhysics(),
                controller: _pageController,
                onPageChanged: (index) {
                  setState(() {
                    _current_page = index;
                  });
                },
                itemBuilder: (context, index) {
                  return carouseView(index);
                }
              ),
            ),
            
            const SizedBox(height: 10,),
            Container(
              width: double.infinity,
              child: Padding(
              padding: const EdgeInsets.only(left: 10,right: 10),
              child: Stack(
                children: [
                  Container(
                    alignment: Alignment.centerLeft,
                    child: Row(
                      children: [
                        Image.asset("assets/icons/like.png",color: Colors.black,width: 20,height: 20,),
                        Padding(
                          padding: const EdgeInsets.only(left: 15,right: 15),
                          child: Image.asset("assets/icons/comment.png",color: Colors.black,width: 20,height: 20,),
                        ),
                        Image.asset("assets/icons/share.png",color: Colors.black,width: 20,height: 20,),
                      ],
                    ),
                  ),
                  Center(
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: List.generate(
                        list_image.length, 
                        (index) => Padding(
                          padding: const EdgeInsets.symmetric(horizontal: 1.0),
                          child: InkWell(
                            onTap: () {
                              _pageController.animateToPage(
                                index, 
                                duration: const Duration(milliseconds: 400), 
                                curve: Curves.easeOut);
                            },
                            child: CircleAvatar(
                              radius: 2,
                              backgroundColor: index == _current_page ? Colors.green : Colors.grey,
                            ),
                          ),
                          ),
                        ),
                    ),
                  ),
                  Align(
                    alignment: Alignment.centerRight,
                    child: Image.asset("assets/icons/save.png",color: Colors.black,width: 20,height: 20,)),
                ],
              ),
                      ),
            ),

          Container(
            margin: const EdgeInsets.only(left: 10,right: 10,top: 10),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                _textUtils.bold14("3,985 views", Colors.black),
                const SizedBox(height: 5,),
                Row(
                  children: [
                    _textUtils.bold14("junaidkhan", Colors.black),
                    const SizedBox(width: 5,),
                    _textUtils.normal14("Hi, this is my first post", Colors.black)
                  ],
                ),

                const SizedBox(height: 5,),
                _textUtils.normal14("View all 6 comments", Colors.grey),
                const SizedBox(height: 5,),
                Row(
                  children: [
                    _textUtils.normal11("12 minutes ago", Colors.grey),
                    const SizedBox(width: 5,),
                    _textUtils.normal11("See Translation", Colors.black),
                  ],
                )
              ],
            ),
          )

        ],
      ),
    );
  }
  
  Widget carouseView(int index) {
    return  Container(
        height: MediaQuery.of(context).size.height * 0.5,
        width: double.infinity,
        decoration: BoxDecoration(
          image: DecorationImage(
            image: AssetImage(list_image[index]) ,
            fit: BoxFit.fill,
            ),
        ),
    );

  }
}

